--------------------------------------------------------------------------------
-- Copyright (c) 2000 by Trenz Electronic.
-- Duenner Kirchweg 77, 32257 Buende, Germany, www.trenz-electronic.de
--     
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--     
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--     
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--------------------------------------------------------------------------------
-- Project:      Application Note: SoC with Xilinx Virtex
-- File:         xsvClkDiv.vhd
-- Description:  48MHz to 24MHz clock divider.
-- Version:      FB, 2001jan29
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;

entity ClkDiv is
	port(
		clk48: in  STD_LOGIC;
		rst:   in  STD_LOGIC;
		clk24: out STD_LOGIC
		);
end ClkDiv;

--------------------------------------------------------------------------------
architecture bhv of ClkDiv is
	--	signal clki: STD_LOGIC;
	signal div: UNSIGNED(1 downto 0);
begin
	--	process(clk48, rst)
	--	begin
	--		if rst= '1' then
	--			clki<= '0';
	--		elsif rising_edge(clk48) then
	--			clki<= not(clki);
	--		end if;
	--	end process;
	--	
	--	clk<= clki;
	
	process(clk48, rst)
	begin
		if rst= '1' then
			div<= (others=> '0');
		elsif rising_edge(clk48) then
			div<= div + 1;
		end if;
	end process;
	
	clk24<= div(0);
	
end bhv;

--------------------------------------------------------------------------------
-- end of file
