--------------------------------------------------------------------------------
-- Copyright (c) 2000 by Trenz Electronic.
-- Duenner Kirchweg 77, 32257 Buende, Germany, www.trenz-electronic.de
--     
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--     
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--     
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--------------------------------------------------------------------------------
-- Project:      Application Note: SoC with Xilinx Virtex
-- File:         xsvFunc.vhd
-- Description:  Functional Block.
-- Version:      FB, 2001mar13
--------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

entity xsvFunc is
	port(
		clk48: in  STD_LOGIC;                      -- 48MHz clock
		rst:   in  STD_LOGIC;                      -- async reset
		dout:  in  STD_LOGIC_VECTOR (15 downto 0); -- 16bit data from USB-Macro
		din:   out STD_LOGIC_VECTOR (15 downto 0); -- 16bit data to USB-Macro
		sl:    out STD_LOGIC_VECTOR (6 downto 0);  -- 7-Segment left
		sr:    out STD_LOGIC_VECTOR (6 downto 0)   -- 7-Segment right
		);
end xsvFunc;

--------------------------------------------------------------------------------
architecture BHV of xsvFunc is
	signal D : STD_LOGIC_VECTOR (15 downto 0);
begin
	d <= dout;
	din <= d;

	sl(0) <= d(0);
	sl(1) <= d(1);
	sl(2) <= d(2);
	sl(3) <= d(3);
	sl(4) <= d(4);
	sl(5) <= d(5);
	sl(6) <= d(6);
	sr(0) <= d(8);
	sr(1) <= d(9);
	sr(2) <= d(10);
	sr(3) <= d(11);
	sr(4) <= d(12);
	sr(5) <= d(13);
	sr(6) <= d(14);
	
end BHV;

--------------------------------------------------------------------------------
-- end of file